const _O = Object;

const _dispersed_eng                                 = require("nv-pg-dispersed-eng");
const _basic                                         = require("nv-loan-admin-basic");
const {DATA_EN2CH,DATA_CH2EN}                        = _basic.def;
const _idlock                                        = require("nv-facutil-idlock"); 
const nofix_eng                                      = require("nv-pg-nofix-eng");
const {OASGN,is_ary,kvlist2d,is_str,instof}       = require("nv-facutil-basic");
const {Manual}                                       = require("nv-facutil-clock");

const  _get_file_ids = (r)=> {
    let ids = [
        ["idcard_front_img",0,{id:r?.idcard_front_img?.id}],
        ["idcard_back_img",0,{id:r?.idcard_back_img?.id}],
        ["vehicle_lic_front_img",0,{id:r?.vehicle_lic_front_img?.id}],
        ["vehicle_lic_back_img",0,{id:r?.vehicle_lic_back_img?.id}]
    ]
    for(let i =0;i<r.contract_imgs.length;i++) {
       let id = r.contract_imgs[i];
       ids.push(["contract_imgs",i,id]);
    }
    for(let i =0;i<r.videos.length;i++) {
       let id = r.videos[i];
       ids.push(["videos",i,id]);
    }
    ids = ids.filter(e=>e[2]!=="");
    return(ids)
}

const  _file_commit  = async(oss,fids) =>{
    return([true,'no_check'])
    /*
    let reasons = [];
    let cond    = true;
    for(let e of fids) {
        let id = e[2].id;
        if(is_str(id) && id.length>0) {
            let obj = await oss.bucket_.get(id);
            if(await obj.exists()) {
            } else {
                cond = false;
                reasons.push([e[0],e[1],"not_exists"])
            }
        } else {
            cond = false;
            reasons.push([e[0],e[1],"not_exists"])
        }
    }
    return([cond,reasons])
    */
}

const _creat_expt_ch_dict = (d)=> {
          let nd = {}
          for(let k in DATA_CH2EN) {
                  let en = DATA_CH2EN[k]
                  let v  = d[en];
                  if(instof(v,_O)) {
                          
                  } else {
                      v = String(v)
                  }
                  nd[k] = v
                  
          }
          let update_at  = new Manual(Number(d.update_at))
          let tmd        = update_at.sdict();
          nd['操作时间'] =  tmd.y + tmd.m + tmd.d;
          return(nd) 
}


const _creat_file_name = (d,k,i='')=> {
    let rslt= (d.操作时间+'_'+d.客户姓名+'_'+d.电话号码+ '_'+k+i+'.'+d[k].type.split("/")[1]);
    delete d[k].type
    return(rslt)
}



const _fill_fary_name = (d,k)=> {
    for(let i=0;i<d[k].length;i++) {
        d[k][i].name = d.操作时间+'_'+d.客户姓名+'_'+d.电话号码+ '_'+k+i+'.'+d[k][i].type.split("/")[1] 
        delete d[k][i].type
    }
}


const _grpby = (rows,k="sheet_id",sort_func=(a,b)=>Number(a.seq-b.seq)) => {
        let d = {}
        for(let row of rows) {
            if(d[row[k]]) {
                 d[row[k]].push(row)
            } else {
                 d[row[k]] =[row]
            }
        }
        let rslt = [];
        for(let k in d) {
             d[k].sort(sort_func);
             let loan_start_at = d[k][0].loan_start_at;
             rslt.push([loan_start_at,k,d[k]])
        }
        rslt.sort((a,b)=>Number(a[0]-b[0]));
        let nd = {}
        for(let e of rslt) {
            let expt = e[2];
            for(let i=0;i<expt.length;i++) {
                expt[i] = _creat_expt_ch_dict(expt[i]);
                expt[i].身份证正面.name = _creat_file_name(expt[i],'身份证正面');
                expt[i].身份证背面.name = _creat_file_name(expt[i],'身份证背面');
                expt[i].行车证正面.name = _creat_file_name(expt[i],'行车证正面');
                expt[i].行车证背面.name = _creat_file_name(expt[i],'行车证背面');      
                _fill_fary_name(expt[i],'合同照片');
                _fill_fary_name(expt[i],'视频');          
            }
            nd[e[1]] = expt
        }
        return(nd)
}




class DataBase extends nofix_eng.DB {
    tbl = 'loan'
    constructor(dbname,tbl,oss) {
        super(dbname);
        this.tbl    = tbl;
        this.lock   = _idlock.creat(); 
        this.oss    = oss;        //OSS.oss    
    }
    //创建贷款
    async creat(cudata) {
        let [cond,data] = _basic.cls.creat(cudata);
        if(cond) {
            let paramd = nofix_eng.DB.INSERT_PARAM.insert_one();
            paramd.tbl = this.tbl;
            paramd.data = data.dict();
            paramd.data.contract_imgs      =["#ary",paramd.data.contract_imgs];
            paramd.data.videos            =["#ary",paramd.data.videos];
            let r                         = await this.insert_one(paramd);
            r = r[0];
            ////获取工单锁
            let sheet_id                 = r.sheet_id;
            await this.lock.acquire(sheet_id);
            ////
            let fids                      = _get_file_ids(r); 
            let [fcond,reasons]           = await _file_commit(this.oss,fids);
            if(fcond) {
                let ch_state              = _basic.def.ACT_EN2CH.file_commit;
                let paramd                = nofix_eng.DB.UPDATE_PARAM.update_with_match();
                paramd.tbl                = this.tbl;
                paramd.cond               = `id==='${r.id}'`;
                paramd.data               = {action:ch_state,all_files_ok:true};
                r                         = await this.update_with_match(paramd);
                ////释放工单锁
                this.lock.release(sheet_id);
                ////
                return([true,r])
            } else {
                ////释放工单锁
                this.lock.release(sheet_id);
                ////                
                return([false,reasons,r])
            }            
        } else {
            return([false,data])
        }
    }
    //
    async _get_entries(sheet_id) {
        let paramd          = nofix_eng.DB.SELECT_PARAM.select_with_match();
        paramd.tbl          = this.tbl;
        paramd.cond         = `sheet_id==='${sheet_id}'`;
        let r               = await this.select_with_match(paramd);
        r.sort((a,b)=>Number(a.seq-b.seq));
        return(r)        
    }
    //
    async _get_fst_entry(sheet_id) {
        let es = await this._get_entries(sheet_id);
        return(es[0])
    }
    async file_commit(cudata) {
        let {oper,sheet_id} = cudata;
        await this.lock.acquire(sheet_id);
        let r                         = await this._get_fst_entry(sheet_id);
        let fids                      = _get_file_ids(r);
        let [fcond,reasons]           = await _file_commit(this.oss,fids);
        if(fcond) {
                let ch_state              = _basic.def.ACT_EN2CH.file_commit;
                let paramd                = nofix_eng.DB.UPDATE_PARAM.update_with_match();
                paramd.tbl                = this.tbl;
                paramd.cond               = `id==='${r.id}'`;
                paramd.data               = {action:ch_state,all_files_ok:true};
                r                         = await this.update_with_match(paramd);
                ////释放工单锁
                this.lock.release(sheet_id);
                ////
                return([true,r])        
        } else {
                ////释放工单锁
                this.lock.release(sheet_id);
                ////                
                return([false,reasons,r])
        }
    }
    async _get_lst_entry(sheet_id) {
        let es = await this._get_entries(sheet_id);
        return(es[es.length-1])
    }    
    async _get_fst_lst_entry(sheet_id) {
        let es = await this._get_entries(sheet_id);
        if(es.length>1) {
           return([es[0],es[es.length-1]])
        } else {
           let e0 = es[0];
           let e1 = {}
           Object.assign(e1,e0)     
           return([e0,e1])
        }
    }
    //获取明细
    async get_details(sheet_id) {
         let es = await this._get_entries(sheet_id);
         return(es.slice(1))
    }
    //更新备注
    async update_extra(cudata) {
         let {sheet_id,oper,extra} = cudata;
         await this.lock.acquire(sheet_id);
         let [fst,lst] = await this._get_fst_lst_entry(sheet_id);
         let extra_str = JSON.stringify(extra);
         extra_str     = extra_str.replace(/'/g,"''");
         let sql = `UPDATE ${this.tbl} SET extra='${extra_str}' WHERE c0='${sheet_id}' AND c1=0  RETURNING *;`;
         let r = await this.exec_raw_sql(sql);
         this.lock.release(sheet_id);
         return([true,r])
    }  
    //审核通过
    async audit(cudata) {
        let {sheet_id,oper} = cudata;
        ////获取工单锁
        await this.lock.acquire(sheet_id);
        ////此时lst 与 fst 一致
        let [fst,lst] = await this._get_fst_lst_entry(sheet_id);
        if(
             fst?.all_files_ok  &&
             fst.id === lst.id
        ) {
            //更新第0条
            let ch_state        = _basic.def.ACT_EN2CH.audit;
            let loan_start_at   = (new Date()).getTime();
            let paramd          = nofix_eng.DB.UPDATE_PARAM.update_with_match();
            paramd.tbl          = this.tbl;
            paramd.cond         = `sheet_id==='${sheet_id}' && seq===0`;
            paramd.data         = {oper,action:ch_state,loan_start_at};
            let r               = await this.update_with_match(paramd);
            //插入更新条目
            //seq 为1 的是初始贷款 loan_incr
            lst.seq             = lst.seq+1n;
            lst.action          = ch_state;
            lst.loan_start_at   = loan_start_at;
            lst.loan_incr       = lst.loan_acc;
            lst.oper            = oper;
            lst.contract_imgs   = ["#ary",lst.contract_imgs];
            lst.videos          = ["#ary",lst.videos];
            paramd              = nofix_eng.DB.INSERT_PARAM.insert_one();
            paramd.tbl          = this.tbl;
            paramd.data         = lst;
            r                   = await this.insert_one(paramd);
            r = r[0];
            this.lock.release(sheet_id);
            return([true,r])
        } else {
            this.lock.release(sheet_id);
            return([false,"有文件未上传或者已经commit"])
        }
    }
    //追加利息
    async interest_incr(cudata) {
        let {sheet_id,oper,interest_incr} = cudata;
        try {
            interest_incr = BigInt(interest_incr);
        } catch(err) {
            return([false,"追加利息数量必须是整数: x.xx乘以100"])
        }
        ////
        if(interest_incr <=0n) {
            return([false,"追加利息数量必须大于0"])
        } else {
            await this.lock.acquire(sheet_id);
            let [fst,lst] = await this._get_fst_lst_entry(sheet_id);
            if(
                fst.action !== _basic.def.ACT_EN2CH.creat &&
                fst.action !== _basic.def.ACT_EN2CH.file_commit
            ) {
                let {interest_acc, interest_lefted}  = lst;
                lst.interest_incr       = interest_incr;
                lst.interest_decr       = 0;  
                lst.interest_acc        = interest_acc    + interest_incr;
                lst.interest_lefted     = interest_lefted + interest_incr;
                lst.seq                 = lst.seq+1n;
                lst.action              = _basic.def.ACT_EN2CH.interest_incr;
                lst.oper                = oper;
                lst.contract_imgs       = ["#ary",lst.contract_imgs];
                lst.videos              = ["#ary",lst.videos];
                let paramd  = nofix_eng.DB.INSERT_PARAM.insert_one();
                paramd.tbl  = this.tbl;
                paramd.data = lst; 
                let r       = await this.insert_one(paramd);
                r = r[0];  
                /////
                fst.interest_acc       = lst.interest_acc;
                fst.interest_lefted    = lst.interest_lefted;
                fst.oper               = oper;
                paramd                 = nofix_eng.DB.UPDATE_PARAM.update_with_match();
                paramd.tbl             = this.tbl;
                paramd.cond            = `sheet_id==='${sheet_id}' && seq===0`;
                paramd.data            = fst;
                let r0 = await this.update_with_match(paramd);
                r0 = r0[0];
                this.lock.release(sheet_id);
                return([true,r,r0])
            } else {
                this.lock.release(sheet_id);
                return([false,"尚未审核"])
            }
        }
    }
    //偿还利息
    async interest_decr(cudata) {
        let {sheet_id,oper,interest_decr} = cudata;
        try {
            interest_decr = BigInt(interest_decr);
        } catch(err) {
            return([false,"偿还利息数量必须是整数: x.xx乘以100"])
        }
        ////
        if(interest_decr <=0n) {
            return([false,"偿还利息数量必须大于0"])
        } else {
            await this.lock.acquire(sheet_id);
            let [fst,lst] = await this._get_fst_lst_entry(sheet_id);
            if(
                fst.action !== _basic.def.ACT_EN2CH.creat &&
                fst.action !== _basic.def.ACT_EN2CH.file_commit
            ) {
                let {interest_payed, interest_lefted}  = lst;
                lst.interest_decr       = interest_decr;
                lst.interest_incr       = 0; 
                lst.interest_payed      = interest_payed  + interest_decr;
                lst.interest_lefted     = interest_lefted - interest_decr;
                lst.seq                 = lst.seq+1n;
                lst.action              = _basic.def.ACT_EN2CH.interest_decr;
                lst.oper                = oper;
                lst.contract_imgs       = ["#ary",lst.contract_imgs];
                lst.videos              = ["#ary",lst.videos];
                let paramd  = nofix_eng.DB.INSERT_PARAM.insert_one();
                paramd.tbl  = this.tbl;
                paramd.data = lst; 
                let r       = await this.insert_one(paramd);
                r = r[0];
                /////
                fst.interest_payed     = lst.interest_payed;
                fst.interest_lefted    = lst.interest_lefted;
                fst.oper               = oper;
                paramd                 = nofix_eng.DB.UPDATE_PARAM.update_with_match();
                paramd.tbl             = this.tbl;
                paramd.cond            = `sheet_id==='${sheet_id}' && seq===0`;
                paramd.data            = fst;
                let r0 = await this.update_with_match(paramd);
                r0 = r0[0];
                this.lock.release(sheet_id);
                return([true,r,r0])
            } else {
                this.lock.release(sheet_id);
                return([false,"尚未审核"])
            }
        }
    }
    //追加本金
    async loan_incr(cudata) {
        let {sheet_id,oper,loan_incr} = cudata;
        try {
            loan_incr = BigInt(loan_incr);
        } catch(err) {
            return([false,"追加本金数量必须是整数: x.xx乘以100"])
        }
        ////
        if(loan_incr <=0n) {
            return([false,"追加本金数量必须大于0"])
        } else {
            await this.lock.acquire(sheet_id);
            let [fst,lst] = await this._get_fst_lst_entry(sheet_id);
            if(
                fst.action !== _basic.def.ACT_EN2CH.creat &&
                fst.action !== _basic.def.ACT_EN2CH.file_commit
            ) {
                let {loan_acc, loan_lefted}  = lst;
                lst.loan_incr       = loan_incr;
                lst.loan_decr       = 0; 
                lst.loan_acc        = loan_acc    + loan_incr;
                lst.loan_lefted     = loan_lefted + loan_incr;
                lst.seq                 = lst.seq+1n;
                lst.action              = _basic.def.ACT_EN2CH.loan_incr;
                lst.oper                = oper;
                lst.contract_imgs       = ["#ary",lst.contract_imgs];
                lst.videos              = ["#ary",lst.videos];
                let paramd  = nofix_eng.DB.INSERT_PARAM.insert_one();
                paramd.tbl  = this.tbl;
                paramd.data = lst; 
                let r       = await this.insert_one(paramd);
                r = r[0]; 
                /////
                fst.loan_acc           = lst.loan_acc;
                fst.loan_lefted        = lst.loan_lefted;
                fst.oper               = oper;
                paramd                 = nofix_eng.DB.UPDATE_PARAM.update_with_match();
                paramd.tbl             = this.tbl;
                paramd.cond            = `sheet_id==='${sheet_id}' && seq===0`;
                paramd.data            = fst;
                let r0 = await this.update_with_match(paramd);
                r0 = r0[0];
                this.lock.release(sheet_id);
                return([true,r,r0])
            } else {
                this.lock.release(sheet_id);
                return([false,"尚未审核"])
            }
        }
    }
    //偿还本金
    async loan_decr(cudata) {
        let {sheet_id,oper,loan_decr} = cudata;
        try {
            loan_decr = BigInt(loan_decr);
        } catch(err) {
            return([false,"偿还本金数量必须是整数: x.xx乘以100"])
        }
        ////
        if(loan_decr <=0n) {
            return([false,"偿还本金数量必须大于0"])
        } else {
            await this.lock.acquire(sheet_id);
            let [fst,lst] = await this._get_fst_lst_entry(sheet_id);
            if(
                fst.action !== _basic.def.ACT_EN2CH.creat &&
                fst.action !== _basic.def.ACT_EN2CH.file_commit
            ) {
                let {loan_payed, loan_lefted}  = lst;
                lst.loan_decr       = loan_decr;
                lst.loan_incr       = 0; 
                lst.loan_payed      = loan_payed  + loan_decr;
                lst.loan_lefted     = loan_lefted - loan_decr;
                lst.seq                 = lst.seq+1n;
                lst.action              = _basic.def.ACT_EN2CH.loan_decr;
                lst.oper                = oper;
                lst.contract_imgs       = ["#ary",lst.contract_imgs];
                lst.videos                  = ["#ary",lst.videos];
                let paramd  = nofix_eng.DB.INSERT_PARAM.insert_one();
                paramd.tbl  = this.tbl;
                paramd.data = lst; 
                let r       = await this.insert_one(paramd);
                r = r[0];
                /////
                fst.loan_payed     = lst.loan_payed;
                fst.loan_lefted    = lst.loan_lefted;
                fst.oper               = oper;
                paramd                 = nofix_eng.DB.UPDATE_PARAM.update_with_match();
                paramd.tbl             = this.tbl;
                paramd.cond            = `sheet_id==='${sheet_id}' && seq===0`;
                paramd.data            = fst;
                let r0 = await this.update_with_match(paramd);
                r0 = r0[0];
                this.lock.release(sheet_id);
                return([true,r,r0])
            } else {
                this.lock.release(sheet_id);
                return([false,"尚未审核"])
            }
        }
    }
    //结束工单
    async finish(cudata) {
        let {sheet_id,oper,force} = cudata;
        await this.lock.acquire(sheet_id);
        let [fst,lst] = await this._get_fst_lst_entry(sheet_id);
        ////
        if(force) {
        } else {
            let {loan_lefted,interest_lefted} = fst;
            if(BigInt(loan_lefted) !== 0n) {
                this.lock.release(sheet_id);
                return([false,"本金尚未还清,使用force:true强制结束"])
            }
            if(BigInt(interest_lefted) !== 0n) {
                this.lock.release(sheet_id);
                return([false,"本金尚未还清,使用force:true强制结束"])
            }            
        }
        ////
        {
                lst.finish_at           = (new Date()).getTime();
                lst.seq                 = lst.seq+1n;
                lst.action              = _basic.def.ACT_EN2CH.finish;
                lst.oper                = oper;
                lst.contract_imgs       = ["#ary",lst.contract_imgs];
                lst.videos              = ["#ary",lst.videos];
                let paramd  = nofix_eng.DB.INSERT_PARAM.insert_one();
                paramd.tbl  = this.tbl;
                paramd.data = lst;
                let r       = await this.insert_one(paramd);   
                r = r[0];     
                //--------------------------------------------------//
                fst.oper               = oper;
                fst.finish_at          = lst.finish_at;
                paramd                 = nofix_eng.DB.UPDATE_PARAM.update_with_match();
                paramd.tbl             = this.tbl;
                paramd.cond            = `sheet_id==='${sheet_id}' && seq===0`;
                paramd.data            = fst;
                let r0 = await this.update_with_match(paramd); 
                r0=r0[0]; 
                this.lock.release(sheet_id);
                return([true,r,r0])      
        }
        ////
    }
    //// 强制删除
    async del(sheet_id) {
        await this.lock.acquire(sheet_id);
        let paramd                 = nofix_eng.DB.DELETE_PARAM.delete_with_match();
        paramd.tbl  = this.tbl;
        paramd.cond = `sheet_id==='${sheet_id}'`;
        let r       = await this.delete_with_match(paramd);
        this.lock.release(sheet_id);
        return([true,r])
    }
    ////数量
    async count(cudata={}) {
            let paramd                 = nofix_eng.DB.COUNT_PARAM.count_of_used();
            paramd.tbl                 = this.tbl;
            paramd.cond                = `seq===0`
            Object.assign(paramd,cudata); 
            let r       = await this.count_of_used(paramd);
            return(r)
    }
    ////获取
    async select(cudata={}) {
            let paramd                 = nofix_eng.DB.SELECT_PARAM.select_with_match();
            paramd.tbl  = this.tbl;
            paramd.cond                = `seq===0`;
            Object.assign(paramd,cudata);
            let r       = await this.select_with_match(paramd);
            return(r)    
    }
    ////導出
    async expt(cudata={}) {
           let paramd                 = nofix_eng.DB.SELECT_PARAM.select_with_match();
           paramd.tbl  = this.tbl;
           Object.assign(paramd,cudata);    
           let ag = this.gen_select_all_with_match(paramd);
           let rslt = []
           for await(let rows of ag) {
               rslt = rslt.concat(rows)
           } 
           rslt = _grpby(rslt); 
           return(rslt) 
    }
    ////统计:
    async stat(cudata={}) {
        /*
        let {y,months,mrange} = cudata;
        if(months === undefined && mrange=== undefined) {
            months = [1,2,3,4,5,6,7,8,9,10,11,12];
        } else if(mrange !== undefined) {
           let [sm,em] = mrange;
           months = [];
           for(let i=sm;i<=em;i=i+1) {
               months.push(i)
           } 
        } else {
        }
        for(let m of months) {
           month_cond.push(`m=${m}`)
        }
        */
        let {y} = cudata;
        let months = [1,2,3,4,5,6,7,8,9,10,11,12];
        let sqld   = {} 
        for(let m of months) {
            let d = {"本金支出":0,"本金收入":0,"利息收入":0,"利息追加":0};
            let loan_incr = await this.exec_raw_sql(
                 `SELECT sum(c22) FROM loan WHERE c1!=0 AND y=${y} AND m=${m} AND (c3='审核通过' OR c3='追加本金');`
            );
            loan_incr = loan_incr[0][0]?.sum??0;
            d["本金支出"] = Number(loan_incr);   
            //// 
            let loan_decr = await this.exec_raw_sql(
                 `SELECT sum(c21) FROM loan WHERE c1!=0 AND y=${y} AND m=${m} AND c3='偿还本金';`
            );
            loan_decr = loan_decr[0][0]?.sum??0;
            d["本金收入"] = Number(loan_decr);            
            ////
            let interest_incr = await this.exec_raw_sql(
                 `SELECT sum(c26) FROM loan WHERE c1!=0 AND y=${y} AND m=${m} AND c3='追加利息';`
            );
            interest_incr  = interest_incr[0][0]?.sum??0;
            d["利息追加"]  = Number(interest_incr); 
            ////
            let interest_decr = await this.exec_raw_sql(
                 `SELECT sum(c27) FROM loan WHERE c1!=0 AND y=${y} AND m=${m} AND c3='偿还利息';`
            );
            interest_decr  = interest_decr[0][0]?.sum??0;
            d["利息收入"]  = Number(interest_decr);            
            sqld[m] = d
        }
        return(sqld)
    }
}

DataBase.PARAMS = {
    select:{
        cond:'jscode-for-match',
        srch_ptrn:'full-text-search-string',
        oper:'AND',
        offset:0,
        limit:1024,
        order_by: [],
        slct_cols: null
    },
    count:{
        cond:'jscode-for-match',
        srch_ptrn:'full-text-search-string',
        oper:'AND'
    },
    del:'sheet_id',
    finish: {
        sheet_id:'',  //工单id
        oper:'',      //操作员,后端自动填写
        force:false   //是否强制删除
    },
    loan_decr: {
        sheet_id:'',
        oper:'',      //操作员,后端自动填写
        loan_decr:100
    },
    loan_incr: {
        sheet_id:'',
        oper:'',      //操作员,后端自动填写
        loan_incr:100
    },
    interest_decr:{
        sheet_id:'',
        oper:'',      //操作员,后端自动填写
        interest_decr:100
    },
    interest_incr:{
        sheet_id:'',
        oper:'',      //操作员,后端自动填写
        interest_incr:100
    },
    get_details:'sheet_id',
    audit: {
        sheet_id:'',
        oper:'',      //操作员,后端自动填写
    },
    update_extra: {
        sheet_id:'',  
        oper:'',      //操作员,后端自动填写
        extra:{},
    },
    creat: {
        oper:'',  //操作员,后端自动填写
        ...{},    //前端数据
    },
    file_commit: {
        sheet_id:'',
        oper:'',      //操作员,后端自动填写
    }
}


const DFLT_ROUTE_PREFIX = "/loan_admin";

const creat_routes = (prefix=DFLT_ROUTE_PREFIX)=> {
    let d = {}
    d[`${prefix}/select`]            = 'select';
    d[`${prefix}/count`]             = 'count'; 
    d[`${prefix}/del`]               = 'del';   
    d[`${prefix}/finish`]            = 'finish';
    d[`${prefix}/loan_decr`]         = 'loan_decr';
    d[`${prefix}/loan_incr`]         = 'loan_incr';
    d[`${prefix}/interest_decr`]     = 'interest_decr';
    d[`${prefix}/interest_incr`]     = 'interest_incr';
    d[`${prefix}/get_details`]       = 'get_details';
    d[`${prefix}/audit`]             = 'audit';
    d[`${prefix}/creat`]             = 'creat';
    d[`${prefix}/file_commit`]       = 'file_commit';
    d[`${prefix}/update_extra`]      = 'update_extra';
    d[`${prefix}/expt`]              = 'expt';
    d[`${prefix}/stat`]              = 'stat';
    return(d)
}

const DFLT_TBL_NAME = 'loan';

const DFLT_DB_NAME  = 'loan_admin';

const init = async (dbname=DFLT_DB_NAME,tbl=DFLT_TBL_NAME,oss)=> {
    let db = new DataBase(dbname,tbl,oss);
    await db.conn();
    return(db)
}


module.exports = {
   DataBase,
   DFLT_ROUTE_PREFIX,creat_routes, 
   DFLT_TBL_NAME, 
   init 
}
